#Blatt 01 - Aufgabe P1
#@date 03-30-2015
#@author diehl@ins.uni-bonn.de

import matplotlib.pyplot as plt
import numpy as np

# f:(1,8) -> R
def f(x):
		if x > 1. and x <=2.:
				return -(x-2.)*(x-2.) + 2.
		if x > 2. and x <= 3.:
				return 2.
		if x > 3 and x <= 4:
				return -(x/2.) + 3.5
		if x > 4 and x <= 5:
				return 1.5
		if x > 5 and x <= 6.:
				return (x-6)*(x-6)*(x-6)+2.5
		if x > 6 and x <= 7.:
				return -(x/2.) + 5.5
		if x > 7. and x <= 8.:
				return (x-7)*(x-7)/4. + 2.


x = np.arange(1.0,8.0,0.1)

#Um eine function mit if-Bedingungen mit numpy zu verwenden 
#muss diese zuerst vectorisiert werden!
vx =  np.vectorize(f)
y = vx(x)

fig = plt.figure()
ax = fig.gca()
ax.text(1.15,1.15,"Infimum")
ax.text(2.,2.025,"Lokales Maxima")
ax.text(4.15,1.4,"Lokales Minima")
ax.text(6,2.5,"Supremum")
ax.text(6.25,1.85,"Strenges\n lokales Minimum")
ax.text(7,2.215,"Strenges\n lokales Maximum")

plt.grid()
plt.xlabel("x")
plt.ylabel("y")
plt.plot(x,y,lw=2)
plt.savefig("./aufgabe01.pdf")

